;Cascade : Rotation et defilement d'une texture dans une entit
Define CamZ.f

InitEngine3D()
InitKeyboard()
InitSprite()

Add3DArchive("Data/Cascade", #PB_3DArchive_FileSystem)
Parse3DScripts()

Window = OpenWindow(#PB_Any,0,0,1024,768,"Cascade")
OpenWindowedScreen(WindowID(window),0,0,1024,768)

WorldShadows(#PB_Shadow_TextureAdditive)

;
; Ambience Lumire blanche
AmbientColor(RGB(255, 255, 255))
CreateLight(#PB_Any,RGB(255, 255, 255), 0,10,100)

;
; Texture
Material = GetScriptMaterial(#PB_Any,"Cascade")
RotateMaterial(Material, 90, #PB_Material_Fixed)

;
; Un mesh
Mesh = LoadMesh(#PB_Any, "Cascade.mesh")

;
; Entit
Entity = CreateEntity(#PB_Any, MeshID(Mesh), MaterialID(Material))
TransformMesh(Mesh, 0,0,0, 1.0,2,0.5, 0,0,0)

;
;Camera 
Camera = CreateCamera(#PB_Any,0,0,100,100)
MoveCamera(camera,0,0,10)
CameraLookAt(camera,0,0,0)

While #True
  
  event = WindowEvent()
  
  If event = #PB_Event_CloseWindow
    Break
  EndIf 
  
  ExamineKeyboard()  
  
  If KeyboardPushed(#PB_Key_Escape)
    Break
  EndIf  
  
  If KeyboardPushed(#PB_Key_Left)
    y+1
  EndIf
  
  If KeyboardPushed(#PB_Key_Right)
    y-1
  EndIf
  
  If KeyboardPushed(#PB_Key_Up)
    x+1
  EndIf
  
  If KeyboardPushed(#PB_Key_Down)
    x-1
  EndIf
 
  RotateEntity(Entity, x,y,z)    
  MoveCamera(Camera,CamX,CamY,CamZ,#PB_Relative)
  CameraLookAt(camera,0,0,0)
  
  RenderWorld()
  FlipBuffers()
Wend 

; IDE Options = PureBasic 5.20 beta 5 (Windows - x86)
; CursorPosition = 22
; FirstLine = 5
; Folding = --
; EnableXP